#!/bin/sh

version=1.00
cfgnam=$1
parnam=$2
parold=$3
parnew=$4
interfaces=/etc/network/interfaces
mrsystem=/etc/mrsystem
mrstart=/etc/mrstart
rocraild=/etc/init.d/rocraild
maecanserver=/etc/init.d/maecanserver
starttok="start-stop-daemon --start --background --exec \$DAEMONPATH/"


to_static() {
	address=`fgrep linux-ipaddress linux.cfg | cut -f 2 -d '"'`
	netmask=`fgrep linux-netmask linux.cfg | cut -f 2 -d '"'`
	network=`fgrep linux-network linux.cfg | cut -f 2 -d '"'`
	gateway=`fgrep linux-gateway linux.cfg | cut -f 2 -d '"'`
	sudo sed -i \
		-e 's;^# *\(iface eth0 inet static\);\1;' \
		-e "s;^# *\(address $address\);\1;" \
		-e "s;^# *\(netmask $netmask\);\1;" \
		-e "s;^# *\(network $network\);\1;" \
		-e "s;^# *\(gateway $gateway\);\1;" \
		-e 's;^\(iface eth0 inet dhcp\);# \1;' $interfaces
}

to_dhcp() {
	address=`fgrep linux-ipaddress linux.cfg | cut -f 2 -d '"'`
	netmask=`fgrep linux-netmask linux.cfg | cut -f 2 -d '"'`
	network=`fgrep linux-network linux.cfg | cut -f 2 -d '"'`
	gateway=`fgrep linux-gateway linux.cfg | cut -f 2 -d '"'`
	sudo sed -i \
		-e 's;^\(iface eth0 inet static\);# \1;' \
		-e "s;^ *\(address $address\);#\1;" \
		-e "s;^ *\(netmask $netmask\);#\1;" \
		-e "s;^ *\(network $network\);#\1;" \
		-e "s;^ *\(gateway $gateway\);#\1;" \
		-e 's;^# *\(iface eth0 inet dhcp\);\1;' $interfaces
}

chg_calue() {
	sudo sed -i \
		-e "s;^ *\($1 $2\);$1 $3;" \
		-e "s;^# *\($1 $2\);#$1 $3;" $interfaces
}

chg_int_mrsystem() {
	sudo sed -i -e "s;^\($1 $2\);$1 $3;" $mrsystem
}

chg_txt_mrsystem() {
	sudo sed -i -e "s;^\($1 \"$2\"\);$1 \"$3\";" $mrsystem
}

chg_txt_mrstart() {
	sudo sed -i -e "s;^\($1 $2\);$1 $3;" $mrstart
}

enable_service() {
	chg_txt_mrstart $1 "start" "start"
	chg_txt_mrstart $1 "stop" "start"
}

disable_service() {
	chg_txt_mrstart $1 "start" "stop"
	chg_txt_mrstart $1 "stop" "stop"
}

chg_ip_mrsystem() {
	oip1=`echo $parold | cut -f 1 -d "."`
	oip2=`echo $parold | cut -f 2 -d "."`
	oip3=`echo $parold | cut -f 3 -d "."`
	oip4=`echo $parold | cut -f 4 -d "."`
	nip1=`echo $parnew | cut -f 1 -d "."`
	nip2=`echo $parnew | cut -f 2 -d "."`
	nip3=`echo $parnew | cut -f 3 -d "."`
	nip4=`echo $parnew | cut -f 4 -d "."`
	sudo sed -i -r -e "s;^$1 \"$oip1\.$oip2\.$oip3\.$oip4\";$1 \"$nip1\.$nip2\.$nip3\.$nip4\";" $mrsystem
}


if [ $cfgnam = "-?" ] ; then
	echo "$0 Version $version"
	echo "shell script for system spcific handleig of UCI web forms"
elif [ $cfgnam = "sysconfig" ] ; then
	if [ $parnam = "linux-dhcp" ] ; then
		if [ $parnew = "off" ] ; then
			to_static
		elif [ $parnew = "on" ] ; then
			to_dhcp
		fi
	elif [ $parnam = "linux-ipadress" ] ; then
		chg_calue address $parold $parnew
	elif [ $parnam = "linux-netmask" ] ; then
		chg_calue netmask $parold $parnew
	elif [ $parnam = "linux-network" ] ; then
		chg_calue network $parold $parnew
	elif [ $parnam = "linux-gateway" ] ; then
		chg_calue gateway $parold $parnew
	elif [ $parnam = "zentrale" ] ; then
		chg_int_mrsystem zentrale $parold $parnew
	elif [ $parnam = "broadcast" ] ; then
		if [ $parold = "off" ] ; then
			if [ $parnew = "off" ] ; then
				to_static
				chg_int_mrsystem broadcast 0 0
			elif [ $parnew = "on" ] ; then
				chg_int_mrsystem broadcast 0 1
			fi
			elif [ $parold = "on" ] ; then
			if [ $parnew = "off" ] ; then
				chg_int_mrsystem broadcast 1 0
			elif [ $parnew = "on" ] ; then
				chg_int_mrsystem broadcast 1 1
			fi
		fi
	elif [ $parnam = "udpbc" ] ; then
		chg_ip_mrsystem udpbc $parold $parnew
	elif [ $parnam = "address" ] ; then
		chg_ip_mrsystem address $parold $parnew
	elif [ $parnam = "port" ] ; then
		chg_int_mrsystem port $parold $parnew
	elif [ $parnam = "interface" ] ; then
		chg_txt_mrsystem interface $parold $parnew
	elif [ $parnam = "can_interface" ] ; then
		chg_txt_mrsystem can_interface $parold $parnew
	elif [ $parnam = "cs2_path" ] ; then
		chg_txt_mrsystem cs2_path $parold $parnew
	elif [ $parnam = "protokoll" ] ; then
		chg_int_mrsystem protokoll $parold $parnew
	elif [ $parnam = "gleissignal" ] ; then
		chg_txt_mrsystem gleissignal $parold $parnew
	elif [ $parnam = "sync" ] ; then
		chg_int_mrsystem sync $parold $parnew
	elif [ $parnam = "conn_tcp" ] ; then
		chg_int_mrsystem conn_tcp $parold $parnew
	elif [ $parnam = "wakeup_s88" ] ; then
		chg_int_mrsystem wakeup_s88 $parold $parnew
	elif [ $parnam = "gpio_s88" ] ; then
		chg_txt_mrsystem gpio_s88 "$parold" "$parnew"
	elif [ $parnam = "hide_ms2" ] ; then
		chg_int_mrsystem hide_ms2 "$parold" "$parnew"
	elif [ $parnam = "emu_host_com" ] ; then
		chg_int_mrsystem emu_host_com "$parold" "$parnew"
	elif [ $parnam = "serial_line" ] ; then
		chg_txt_mrsystem serial_line "$parold" "$parnew"
	elif [ $parnam = "num_lokfkt" ] ; then
		webpath=`cat $mrsystem | fgrep cs2_path | cut -f 2 -d "\""`
		if [ -d "$webpath" ] ; then
			rm $webpath/lokomotive.*
		fi
		chg_int_mrsystem num_lokfkt "$parold" "$parnew"
	elif [ $parnam = "update_file" ] ; then
		full_name="/home/developer/updates/"$parnew
		sudo /usr/local/bin/mrupdate $full_name
	elif [ $parnam = "reboot" ] ; then
		chg_txt_mrsystem cs2_path $parold $parnew
		if [ $parnew = "System" ] ; then
			sudo /sbin/reboot
		elif [ $parnew = "MRSystem" ] ; then
			sudo /etc/init.d/mrsystem restart
		elif [ $parnew = "Anhalten" ] ; then
			sudo /sbin//halt
		fi
	elif [ $parnam = "client_cc" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrcc"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrcc"
		fi
	elif [ $parnam = "client_cs2eth" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrcs2eth"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrcs2eth"
		fi
	elif [ $parnam = "client_cs2sl" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrcs2sl"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrcs2sl"
		fi
	elif [ $parnam = "client_ms1" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrms1"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrms1"
		fi
	elif [ $parnam = "client_ms2" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrms2"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrms2"
		fi
	elif [ $parnam = "client_ms24l" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrms24l"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrms24l"
		fi
	elif [ $parnam = "client_slcan" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrslcan"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrslcan"
		fi
	elif [ $parnam = "client_zentrale" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrzentrale"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrzentrale"
		fi
	elif [ $parnam = "client_gpios88" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "startmrgpios88"
		elif [ $parnew = "stop" ] ; then
			disable_service "startmrgpios88"
		fi
	elif [ $parnam = "client_cceth" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrcceth"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrcceth"
		fi
	elif [ $parnam = "client_srcp" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrsrcp"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrsrcp"
		fi
	elif [ $parnam = "client_tty" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "mrtty"
		elif [ $parnew = "stop" ] ; then
			disable_service "mrtty"
		fi
	elif [ $parnam = "drehscheibe" ] ; then
		if [ $parnew = "start" ] ; then
			enable_service "drehscheibe"
		elif [ $parnew = "stop" ] ; then
			disable_service "drehscheibe"
		fi
	elif [ $parnam = "rocrail" ] ; then
		if [ $parnew = "enable" ] ; then
			sudo sed -i -e "s;^#      nohup;      nohup;" $rocraild
			sudo sed -i -e "s;^#      kill;      kill;" $rocraild
		elif [ $parnew = "disable" ] ; then
			sudo sed -i -e "s;^      nohup;#      nohup;" $rocraild
			sudo sed -i -e "s;^      kill;#      kill;" $rocraild
		fi
	fi
	elif [ $parnam = "maecanserver" ] ; then
		if [ $parnew = "enable" ] ; then
			sudo sed -i -e "s;^#\tcd;\tcd;" $maecanserver
			sudo sed -i -e "s;^#\tkillall;\tkillall;" $maecanserver
		elif [ $parnew = "disable" ] ; then
			sudo sed -i -e "s;^\tcd;#\tcd;" $maecanserver
			sudo sed -i -e "s;^\tkillall;#\tkillall;" $maecanserver
		fi
	fi
fi
